package cz.cuni.mff.java.threads;

public class SimpleMutex {

    private boolean locked;

    public SimpleMutex() {
        locked = false;
    }

    synchronized public boolean lock() {
        try {
            while (locked) {
                wait();
            }
            locked = true;
        } catch (InterruptedException e) {
            return false;
        }
        return true;
    }

    synchronized public boolean tryLock() {
        if (locked) {
            return false;
        } else {
            locked = true;
            return true;
        }
    }

    synchronized public void unlock() {
        locked = false;
        notify();
    }

}
