package cz.cuni.mff.java.threads;

public class SimpleMutexExample extends Thread {

    public static class Resource {
        private long data;
        public void doSomething() {
		    data++;
	    }

        public long getData() {
            return data;
        }
    }

    private final SimpleMutex mutex;
    private final Resource resource;

    public SimpleMutexExample(Resource resource, SimpleMutex mutex) {
        this.resource = resource;
        this.mutex = mutex;
    }

    @Override
    public void run() {
        try {
            if (mutex.lock()) {
                resource.doSomething();
            }
        } finally {
            mutex.unlock();
        }
    }

    public static void main(String[] argv) {
        Resource resource = new Resource();
        SimpleMutex mutex = new SimpleMutex();
        Thread[] ths = { new SimpleMutexExample(resource, mutex),
                         new SimpleMutexExample(resource, mutex),
                         new SimpleMutexExample(resource, mutex) };

        for (Thread t : ths) {
            t.start();
        }
        for (Thread t : ths) {
            try {
                t.join();
            } catch (InterruptedException ex) {
                System.out.println("Interrupted exception occurred");
            }
        }
        System.out.println(resource.getData());
    }
}
